<?php

namespace App\Services\Part;

use App\Entities\Equipment\ServerPartEntity;
use App\Helpers\CommonHelper;
use App\Models\CommonModel;
use App\Services\CommonService;

abstract class PartService extends CommonService
{
    protected function __construct(CommonModel $model, CommonHelper $helper)
    {
        parent::__construct($model, $helper);
        $this->addClassName('Part');
    }

    //서버파트관련 작업
    public function setServerPart(string $action, ServerPartEntity $oldServerPartEntity, ServerPartEntity $serverPartEntity, array $serverPartDatas): mixed
    {
        switch ($action) {
            case 'create':
                //부품정보가져오기
                $entity = $this->getEntity($serverPartEntity->getPartUID());
                if (!$entity) {
                    throw new \Exception("{$serverPartEntity->getPartUID()}에 해당하는 부품정보를 찾을수없습니다.");
                }
                //부품정보에 서버정보 설정 및 서비스,고객정보 정의
                if ($entity->getStock() < $serverPartEntity->getCnt()) {
                    throw new \Exception("현재 재고수[{$entity->getStock()}]보다 지정하신 갯수({$serverPartEntity->getCnt()})가 더 많습니다.");
                }
                $entity = parent::modify($entity, ['stock' => $entity->getStock() - $serverPartEntity->getCnt()]);
                break;
            case 'modify':
                //수정 전 부품연결정보관련 정보처리  갯수,파트가 달라졌을경우 (회수 -> 사용 처리)
                //기존것 회수 처리
                if ($oldServerPartEntity->getCnt() != $serverPartEntity->getCnt() ||  $oldServerPartEntity->getPartUID() !== $serverPartEntity->getPartUID()) {
                    $this->setServerPart('delete', $oldServerPartEntity,   $serverPartEntity, $serverPartDatas);
                }
                //신규것 사용처리
                $entity = $this->setServerPart('create', $oldServerPartEntity,   $serverPartEntity, $serverPartDatas);
                break;
            case 'delete': //반드시 oldServerPartEntity 사용해야함
                //부품정보가져오기
                $entity = $this->getEntity($oldServerPartEntity->getPartUID());
                if (!$entity) {
                    throw new \Exception("{$oldServerPartEntity->getPartUID()}에 해당하는 부품정보를 찾을수없습니다.");
                }
                //부품정보에 서버정보 설정 및 서비스,고객정보 정의
                if ($entity->getStock() < $oldServerPartEntity->getCnt()) {
                    throw new \Exception("현재 재고수[{$entity->getStock()}]보다 지정하신 갯수({$oldServerPartEntity->getCnt()})가 더 많습니다.");
                }
                $entity = parent::modify($entity, ['stock' => $entity->getStock() + $oldServerPartEntity->getCnt()]);
                break;
        }
        return $entity;
    }
}
